package it.unibo.tw0708.web;

import it.unibo.tw0708.utils.Declaration;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Another servlet
 *
 * @author pisi79
 */
public class YourServlet 
extends HttpServlet {
	
	private static final long serialVersionUID = -7822739649809280754L;

	/**
	 * This servlet forwards the request processing of HTTP POST requests
	 * to the method handling HTTP GET ones.
	 * This way, the servlet can be invoked by submitting both request types
	 */
	public void doPost(HttpServletRequest request,
            HttpServletResponse response)
    throws IOException, ServletException {
    	this.doGet(request,response);
    }

	/**
	 * Requests are served by invoking library functions
	 * and returning html-wrapped results 
	 */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {

    	// this is where we are gonna write html results
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

            // title
		    out.println("<title>Declaration Servlet</title>");
	
		    // style
		    out.println("<link rel=\"stylesheet\" href=\"styles/default.css\" type=\"text/css\"></link>");
	
        out.println("</head>");
	
        out.println("<body>");

        out.println("<div id=\"main\">");

	        String name = request.getParameter("name");
	        String surname = request.getParameter("surname");
	        String gender = request.getParameter("gender");
	        boolean male = true;
	        if ( gender != null ) 
	        	male = gender.equals("m");

	        String address = request.getParameter("address");
	        String city = request.getParameter("city");
	        String country = request.getParameter("country");

	        String declaresThat = request.getParameter("declaresThat");

	        try {
	        	Declaration d = new Declaration(name,surname,male);
	        	d.set(address,city,country);
	        	String declaration = d.declaresThat(declaresThat);
	            out.println("<p>" + declaration + "</p>");
	            
	            // Easter Egg!!! To check if exceptions are handled rightly
	            // we throw one if address city and country are all equals to '666'
	            if ( address != null && city != null && country != null ) {
	            	if ( address.equals("666") && city.equals("666") && country.equals("666") )
	            		throw new Exception("Who is gonna trust devil's word?");
	            }
	            
	        }
	        catch (Exception e) {
	        	throw new ServletException(e.getMessage());
			}

            out.println("</div>");

        out.println("</body>");
	        
        out.println("</html>");

    }

}